;(() => {
    var __webpack_exports__ = {}

    // Audio settings
    audio.volume = localStorage.getItem('audioVolume') == null ? 0.8 : localStorage.getItem('audioVolume')
    audio.loop = true
    audio.play()

    // Toggle audio button
    $('#toggleAudio').on('click', function () {
        audio.volume = audio.volume == 0 ? 0.8 : 0
        audio.play()
        localStorage.setItem('audioVolume', audio.volume)
        const muteSrc = $(this).data('mute-src');
        const normalSrc = $(this).data('normal-src');
        $(this).attr('src', audio.volume == 0 ? muteSrc : normalSrc);
    });


    // Button click event
    $(document).ready(function() {
        $('.btn-start-input').on('click', function () {
            $('#welcome').fadeOut(500);
            $('#form-code').fadeIn(1000);
            audio.play();
        });
    });

    // Create boxes
    for (var i = 0; i < segments.length; i++) {
        createBox(segments[i].id)
    }

    // Function to create box
    function createBox(id) {
        var cube = document.querySelector('#cube_' + id);
        var back = document.querySelector('#back_' + id);
        var top = document.querySelector('#top_' + id);
        var left = document.querySelector('#left_' + id);
        var right = document.querySelector('#right_' + id);
        var hexagon = document.querySelector('#hexagon_' + id);
        var powerup = document.querySelector('#powerup_' + id);
        var duration = '750ms';

        cube.addEventListener("click", openCube);
        top.style.transition = 'all ' + duration;
        left.style.transition = 'all ' + duration;
        right.style.transition = 'all ' + duration;
        cube.style.transition = 'all ' + duration;
        powerup.style.transition = 'all ' + duration;
        hexagon.style.transition = 'all ' + duration;
        back.style.transition = 'all ' + duration;
    }

    // Function to open cube
    function openCube(id, prize) {
        var cube = document.querySelector('#cube_' + id);
        var back = document.querySelector('#back_' + id);
        var top = document.querySelector('#top_' + id);
        var left = document.querySelector('#left_' + id);
        var right = document.querySelector('#right_' + id);
        var hexagon = document.querySelector('#hexagon_' + id);
        var powerup = document.querySelector('#powerup_' + id);
        var isMobile = /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent);
        var duration = '750ms';

        top.style.transform = 'translateY(-3rem)';
        left.style.transform = isMobile ? 'translateX(-1rem)' : 'translateX(-3rem)';
        right.style.transform = isMobile ? 'translateX(1rem)' : 'translateX(3rem)';
        top.style.opacity = 0.6;
        left.style.opacity = 0.6;
        right.style.opacity = 0.6;
        back.style.opacity = 1;
        hexagon.style.opacity = 0.5;
        powerup.style.opacity = 1;
        isOpen = true;

        cube.style.animationPlayState = 'paused';
        powerup.style.zIndex = 10;
        powerup.style.height = '80px';
        powerup.style.width = '80px';

        if (prize != null) {
            var prizeImageUrl = prize.item_image;
            powerup.style.backgroundImage = 'url(' + prizeImageUrl + ')';
        } else {
            powerup.style.backgroundImage = "url('{{ asset('mystery-box/img/prize_zonk.webp') }}')";
        }
    }

    // Show prizes button click event
    $('#show-prizes').on('click', function () {
        audio.play();
        for (var i = 0; i < segments.length; i++) {
            openCube(segments[i].id, segments[i]);
        }
        $('.btn-start-input').css('display', 'block')
        $('#welcome').fadeOut(500)
    })

// Activate button click event
$('#activate').on('click', function() {
    var coupon = $('#code').val();
    var username = $('#username').val();

    if (coupon == "") {
        Swal.fire({
            icon: 'warning',
            title: 'Silahkan masukan kode voucher',
            showConfirmButton: false,
            timer: 1500
        });
    } else {
        $.ajax({
            url: '/luckybox/redeem',
            type: 'POST',
            data: {
                coupon: coupon,
                username: username
            },
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            },
            success: function(response) {
                if (response.message == "success") {
                    Swal.fire({
                        icon: 'success',
                        title: 'Semoga Beruntung',
                        showConfirmButton: false,
                        timer: 2500
                    }).then((value) => {
                        window.location.href = '/luckybox/start';
                    });
                } else {
                    Swal.fire({
                        icon: 'error',
                        title: 'Oops...',
                        text: 'Kode voucher invalid / telah digunakan!',
                        footer: '<a href="">Dapatkan kode voucher disini</a>'
                    });
                }
            },
            error: function(data) {
                console.log('Error:', data);
            }
        });
    }
});

    // Redirect if not in luckybox page
    !window.location.href.includes('luckybox') &&
    ($('html').empty(),
    $('html').html(
        '<div style="background-color: black; width: 100vw; height: 100vh; color: white;">Please contact the developer, don\'t you dare try to duplicate this game or you will be ruined.</div>'
    ))
})();
